/*
 * MemoryTimer.java
 *
 * Created on 15. August 2002, 18:38
 */

/**
 *
 * @author  Markus Eichenberger
 */
public class MemoryTimer extends Thread {
    
    private int m_nTimeout = -1;
    private Memory m_memory;
    
    /** MemoryTimer
     * @param nTimeout Timeout in milli seconds
     * @param memory Memory
     */
    public MemoryTimer(int nTimeout, Memory memory) {
        m_nTimeout = nTimeout;
        m_memory = memory;
        start();
    }
    
   /** Wait for timeout and callback the memory game
    */
    public void run() {
        if(m_nTimeout > 0) {
            try {
                Thread.sleep(m_nTimeout);
            }
            catch(InterruptedException e) { }
        }
        m_memory.timeExpired();
    }
}
